Index: /LMDZ5/branches/testing/libf/phylmd/ocean_slab_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/ocean_slab_mod.F90	(revision 2668)
+++ /LMDZ5/branches/testing/libf/phylmd/ocean_slab_mod.F90	(revision 2669)
@@ -672,5 +892,5 @@
     END IF ! coupling time
     
-    !tests fraction glace
+    !tests ice fraction 
     WHERE (fsic.LT.ice_frac_min)
         tslab(:,1)=tslab(:,1)-fsic*seaice*ice_lat*cyang
@@ -691,9 +911,14 @@
     IF (ALLOCATED(tslab)) DEALLOCATE(tslab)
     IF (ALLOCATED(fsic)) DEALLOCATE(fsic)
+    IF (ALLOCATED(tice)) DEALLOCATE(tice)
+    IF (ALLOCATED(seaice)) DEALLOCATE(seaice)
     IF (ALLOCATED(slab_bils)) DEALLOCATE(slab_bils)
     IF (ALLOCATED(slab_bilg)) DEALLOCATE(slab_bilg)
     IF (ALLOCATED(bilg_cum)) DEALLOCATE(bilg_cum)
     IF (ALLOCATED(bils_cum)) DEALLOCATE(bils_cum)
-    IF (ALLOCATED(tslab)) DEALLOCATE(tslab)
+    IF (ALLOCATED(taux_cum)) DEALLOCATE(taux_cum)
+    IF (ALLOCATED(tauy_cum)) DEALLOCATE(tauy_cum)
+    IF (ALLOCATED(dt_ekman)) DEALLOCATE(dt_ekman)
+    IF (ALLOCATED(dt_hdiff)) DEALLOCATE(dt_hdiff)
 
   END SUBROUTINE ocean_slab_final
Index: /LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2668)
+++ /LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2669)
@@ -3095,4 +3095,19 @@
                 endif
                 mfois(nsrf) = mfois(nsrf) + 1
+                ! F. Codron sensible default values for ocean and sea ice
+                IF (nsrf.EQ.is_oce) THEN
+                    tsurf(i,nsrf) = 271.35 ! Freezing sea water
+                    DO k=1,nsw
+                      alb_dir(i,k,nsrf) = 0.06 ! typical Ocean albedo
+                      alb_dif(i,k,nsrf) = 0.06
+                    END DO
+                ELSE IF (nsrf.EQ.is_sic) THEN
+                    tsurf(i,nsrf) = 273.15 ! Melting ice 
+                    DO k=1,nsw
+                      alb_dir(i,k,nsrf) = 0.3 ! thin ice
+                      alb_dif(i,k,nsrf) = 0.3
+                    END DO
+                END IF
+                ! F. Codron
              ELSE
                 ! The continents have changed. The new fraction receives the mean sum of the existent fractions
Index: /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2668)
+++ /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2669)
@@ -3,5 +3,5 @@
 SUBROUTINE phyetat0 (fichnom, clesphy0, tabcntr0)
 
-  USE dimphy, only: klon, zmasq, klev, nslay
+  USE dimphy, only: klon, zmasq, klev
   USE iophy, ONLY : init_iophy_new
   USE ocean_cpl_mod,    ONLY : ocean_cpl_init
@@ -25,5 +25,5 @@
   USE carbon_cycle_mod, ONLY : carbon_cycle_tr, carbon_cycle_cpl, co2_send
   USE indice_sol_mod, only: nbsrf, is_ter, epsfra, is_lic, is_oce, is_sic
-  USE ocean_slab_mod, ONLY: tslab, seaice, tice, ocean_slab_init
+  USE ocean_slab_mod, ONLY: nslay, tslab, seaice, tice, ocean_slab_init
   USE time_phylmdz_mod, ONLY: init_iteration, pdtphys, itau_phy
 
@@ -443,5 +443,15 @@
   IF ( type_ocean == 'slab' ) THEN
       CALL ocean_slab_init(dtime, pctsrf)
-      found=phyetat0_get(nslay,tslab,"tslab","tslab",0.)
+      IF (nslay.EQ.1) THEN
+        found=phyetat0_get(1,tslab,"tslab01","tslab",0.)
+        IF (.NOT. found) THEN
+            found=phyetat0_get(1,tslab,"tslab","tslab",0.)
+        END IF
+      ELSE
+          DO i=1,nslay
+            WRITE(str2,'(i2.2)') i
+            found=phyetat0_get(1,tslab(:,i),"tslab"//str2,"tslab",0.)  
+          END DO
+      END IF
       IF (.NOT. found) THEN 
           PRINT*, "phyetat0: Le champ <tslab> est absent"
@@ -453,6 +463,6 @@
 
       ! Sea ice variables
-      found=phyetat0_get(1,tice,"slab_tice","slab_tice",0.)
       IF (version_ocean == 'sicINT') THEN
+          found=phyetat0_get(1,tice,"slab_tice","slab_tice",0.)
           IF (.NOT. found) THEN 
               PRINT*, "phyetat0: Le champ <tice> est absent"
@@ -460,4 +470,5 @@
                   tice(:)=ftsol(:,is_sic)
           END IF 
+          found=phyetat0_get(1,seaice,"seaice","seaice",0.)
           IF (.NOT. found) THEN
               PRINT*, "phyetat0: Le champ <seaice> est absent"
Index: /LMDZ5/branches/testing/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2668)
+++ /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2669)
@@ -30,5 +30,5 @@
   USE indice_sol_mod, ONLY: nbsrf, is_oce, is_sic, is_ter, is_lic, epsfra
   USE surface_data, ONLY: type_ocean, version_ocean
-  USE ocean_slab_mod, ONLY : tslab, seaice, tice, fsic
+  USE ocean_slab_mod, ONLY : nslay, tslab, seaice, tice, fsic
   USE time_phylmdz_mod, ONLY: annee_ref, day_end, itau_phy, pdtphys
 
@@ -58,5 +58,5 @@
 
   INTEGER isoil, nsrf,isw
-  CHARACTER (len=7) :: str7
+  CHARACTER (len=2) :: str2
   CHARACTER (len=256) :: nam, lnam
   INTEGER           :: it, iiq
@@ -304,5 +304,12 @@
   ! Restart variables for Slab ocean
   IF (type_ocean == 'slab') THEN
-      CALL put_field("tslab", "Slab ocean temperature", tslab)
+      IF (nslay.EQ.1) THEN
+        CALL put_field("tslab", "Slab ocean temperature", tslab)
+      ELSE
+        DO it=1,nslay
+          WRITE(str2,'(i2.2)') it
+          CALL put_field("tslab"//str2, "Slab ocean temperature", tslab(:,it))
+        END DO
+      END IF
       IF (version_ocean == 'sicINT') THEN
           CALL put_field("seaice", "Slab seaice (kg/m2)", seaice)
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2668)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2669)
@@ -677,4 +677,8 @@
   TYPE(ctrl_out), SAVE :: o_slab_sic = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
     'seaice', 'Epaisseur banquise slab', 'kg/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_slab_hdiff = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
+    'slab_hdiff', 'Horizontal diffusion', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_slab_ekman = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
+    'slab_ekman', 'Ekman heat transport', 'W/m2', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_ale_bl = ctrl_out((/ 1, 1, 1, 10, 10, 10, 11, 11, 11 /), &
     'ale_bl', 'ALE BL', 'm2/s2', (/ ('', i=1, 9) /))
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2668)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2669)
@@ -24,5 +24,5 @@
     ! defined and initialised in phys_output_mod.F90
 
-    USE dimphy, only: klon, klev, klevp1, nslay
+    USE dimphy, only: klon, klev, klevp1
     USE mod_phys_lmdz_para, ONLY: is_north_pole_phy,is_south_pole_phy
     USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
@@ -89,4 +89,5 @@
          o_slab_qflux, o_tslab, o_slab_bils, &
          o_slab_bilg, o_slab_sic, o_slab_tice, &
+         o_slab_hdiff, o_slab_ekman, &
          o_weakinv, o_dthmin, o_cldtau, &
          o_cldemi, o_pr_con_l, o_pr_con_i, &
@@ -291,5 +292,6 @@
   
 
-    USE ocean_slab_mod, only: tslab, slab_bils, slab_bilg, tice, seaice
+    USE ocean_slab_mod, only: nslay, tslab, slab_bils, slab_bilg, tice, &
+        seaice, slab_ekman,slab_hdiff, dt_ekman, dt_hdiff
     USE pbl_surface_mod, only: snow
     USE indice_sol_mod, only: nbsrf
@@ -312,4 +314,7 @@
     USE phys_cal_mod, only : mth_len
 
+#ifdef CPP_RRTM
+    USE YOESW, ONLY : RSUN
+#endif
 
     IMPLICIT NONE
@@ -355,4 +360,6 @@
 #endif
     REAL, PARAMETER :: un_jour=86400.
+    INTEGER ISW
+    CHARACTER*1 ch1
 
     ! On calcul le nouveau tau:
@@ -403,4 +410,30 @@
        CALL histwrite_phy(o_contfracOR, pctsrf(:,is_ter))
        CALL histwrite_phy(o_aireTER, paire_ter)
+!
+#ifdef CPP_XIOS
+       CALL histwrite_phy("R_ecc",R_ecc)
+       CALL histwrite_phy("R_peri",R_peri)
+       CALL histwrite_phy("R_incl",R_incl)
+       CALL histwrite_phy("solaire",solaire)
+!
+#ifdef CPP_RRTM
+      IF (iflag_rrtm.EQ.1) THEN
+        DO ISW=1, NSW
+          WRITE(ch1,'(i1)') ISW
+!         zx_tmp_0d=RSUN(ISW)
+!         CALL histwrite_phy("rsun"//ch1,zx_tmp_0d)
+          CALL histwrite_phy("rsun"//ch1,RSUN(ISW))
+        ENDDO
+      ENDIF
+#endif
+!
+       CALL histwrite_phy("co2_ppm",co2_ppm)
+       CALL histwrite_phy("CH4_ppb",CH4_ppb)
+       CALL histwrite_phy("N2O_ppb",N2O_ppb)
+       CALL histwrite_phy("CFC11_ppt",CFC11_ppt)
+       CALL histwrite_phy("CFC12_ppt",CFC12_ppt)
+!
+#endif
+
 !!! Champs 2D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 ! Simulateur AIRS
@@ -951,5 +984,5 @@
               CALL histwrite_phy(o_tslab, zx_tmp_fi2d)
           ELSE
-              CALL histwrite_phy(o_tslab, tslab)
+              CALL histwrite_phy(o_tslab, tslab(:,1:nslay))
           END IF
           IF (version_ocean=='sicINT') THEN
@@ -957,4 +990,20 @@
               CALL histwrite_phy(o_slab_tice, tice)
               CALL histwrite_phy(o_slab_sic, seaice)
+          END IF
+          IF (slab_hdiff) THEN
+            IF (nslay.EQ.1) THEN
+                zx_tmp_fi2d(:)=dt_hdiff(:,1)
+                CALL histwrite_phy(o_slab_hdiff, zx_tmp_fi2d)
+            ELSE
+                CALL histwrite_phy(o_slab_hdiff, dt_hdiff(:,1:nslay))
+            END IF
+          END IF
+          IF (slab_ekman.GT.0) THEN
+            IF (nslay.EQ.1) THEN
+                zx_tmp_fi2d(:)=dt_ekman(:,1)
+                CALL histwrite_phy(o_slab_ekman, zx_tmp_fi2d)
+            ELSE
+                CALL histwrite_phy(o_slab_ekman, dt_ekman(:,1:nslay))
+            END IF
           END IF
        ENDIF !type_ocean == force/slab
Index: /LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2668)
+++ /LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2669)
@@ -233,5 +233,7 @@
     USE ioipsl_getin_p_mod, ONLY : getin_p
 
+#ifndef CPP_XIOS
     USE paramLMDZ_phy_mod
+#endif
 
     USE cmp_seri_mod
@@ -582,6 +584,6 @@
     LOGICAL,SAVE :: ok_adjwk=.FALSE.
     !$OMP THREADPRIVATE(ok_adjwk) 
-    REAL,SAVE :: oliqmax=999.
-    !$OMP THREADPRIVATE(oliqmax) 
+    REAL,SAVE :: oliqmax=999.,oicemax=999.
+    !$OMP THREADPRIVATE(oliqmax,oicemax) 
     REAL, SAVE :: alp_offset
     !$OMP THREADPRIVATE(alp_offset)
@@ -983,4 +985,6 @@
     INTEGER, SAVE :: flag_aerosol 
     !$OMP THREADPRIVATE(flag_aerosol) 
+    LOGICAL, SAVE :: flag_bc_internal_mixture
+    !$OMP THREADPRIVATE(flag_bc_internal_mixture)
     LOGICAL, SAVE :: new_aod
     !$OMP THREADPRIVATE(new_aod) 
@@ -1011,8 +1015,4 @@
     ! edges of pressure intervals for ozone climatologies, in Pa, in strictly
     ! ascending order
-
-    integer, save:: co3i = 0
-    !     time index in NetCDF file of current ozone fields
-    !$OMP THREADPRIVATE(co3i) 
 
     integer ro3i
@@ -1140,5 +1140,5 @@
             ok_ade, ok_aie, ok_cdnc, aerosol_couple,  &
             flag_aerosol, flag_aerosol_strat, new_aod, &
-            bl95_b0, bl95_b1, &
+            flag_bc_internal_mixture, bl95_b0, bl95_b1, &
                                 ! nv flags pour la convection et les
                                 ! poches froides
@@ -1197,4 +1197,5 @@
        CALL getin_p('ok_adjwk',ok_adjwk)
        CALL getin_p('oliqmax',oliqmax)
+       CALL getin_p('oicemax',oicemax)
        CALL getin_p('ratqsp0',ratqsp0)
        CALL getin_p('ratqsdp',ratqsdp)
@@ -1551,5 +1552,7 @@
        WRITE(lunout,*)'OK freq_outNMC(3)=',freq_outNMC(3)
 
+#ifndef CPP_XIOS
        CALL ini_paramLMDZ_phy(dtime,nid_ctesGCM)
+#endif
 
 #endif
@@ -1906,51 +1909,47 @@
     ! Prescrire l'ozone et calculer l'albedo sur l'ocean.
     !
-    if (read_climoz >= 1) then
-       ! Ozone from a file
-       ! Update required ozone index:
-       ro3i = int((days_elapsed + jh_cur - jh_1jan) / year_len * 360.) + 1
-       if (ro3i == 361) ro3i = 360
-       ! (This should never occur, except perhaps because of roundup
-       ! error. See documentation.)
-       if (ro3i /= co3i) then
-          ! Update ozone field:
-          if (read_climoz == 1) then
-             call regr_pr_av(ncid_climoz, (/"tro3"/), julien=ro3i, &
-                  press_in_edg=press_climoz, paprs=paprs, v3=wo)
-          else
-             ! read_climoz == 2
-             call regr_pr_av(ncid_climoz, (/"tro3         ", &
-                  "tro3_daylight"/), julien=ro3i, press_in_edg=press_climoz, &
-                  paprs=paprs, v3=wo)
-          end if
-          ! Convert from mole fraction of ozone to column density of ozone in a
-          ! cell, in kDU:
-          forall (l = 1: read_climoz) wo(:, :, l) = wo(:, :, l) * rmo3 / rmd &
-               * zmasse / dobson_u / 1e3
-          ! (By regridding ozone values for LMDZ only once every 360th of
-          ! year, we have already neglected the variation of pressure in one
-          ! 360th of year. So do not recompute "wo" at each time step even if
-          ! "zmasse" changes a little.)
-          co3i = ro3i
-       end if
-    ELSEIF (MOD(itap-1,lmt_pas) == 0) THEN
+    ! Update ozone if day change
+    IF (MOD(itap-1,lmt_pas) == 0) THEN
+      IF (read_climoz == 0) THEN
        ! Once per day, update ozone from Royer:
-
-       IF (solarlong0<-999.) then
-          ! Generic case with evolvoing season
-          zzz=real(days_elapsed+1)
-       ELSE IF (abs(solarlong0-1000.)<1.e-4) then
-          ! Particular case with annual mean insolation
-          zzz=real(90) ! could be revisited
-          IF (read_climoz/=-1) THEN
-             abort_message ='read_climoz=-1 is recommended when ' &
-                  // 'solarlong0=1000.'
-             CALL abort_physic (modname,abort_message,1)
-          ENDIF
-       ELSE
+        IF (solarlong0<-999.) then
+           ! Generic case with evolvoing season
+           zzz=real(days_elapsed+1)
+        ELSE IF (abs(solarlong0-1000.)<1.e-4) then
+           ! Particular case with annual mean insolation
+           zzz=real(90) ! could be revisited
+           IF (read_climoz/=-1) THEN
+              abort_message ='read_climoz=-1 is recommended when ' &
+                   // 'solarlong0=1000.'
+              CALL abort_physic (modname,abort_message,1)
+           ENDIF
+        ELSE
           ! Case where the season is imposed with solarlong0
           zzz=real(90) ! could be revisited
-       ENDIF
-       wo(:,:,1)=ozonecm(latitude_deg, paprs,read_climoz,rjour=zzz)
+        ENDIF
+
+        wo(:,:,1)=ozonecm(latitude_deg, paprs,read_climoz,rjour=zzz)
+      ELSE
+        ro3i = int((days_elapsed + jh_cur - jh_1jan) / year_len * 360.) + 1   
+        if (ro3i == 361) ro3i = 360
+        if (read_climoz == 1) then
+           call regr_pr_av(ncid_climoz, (/"tro3"/), julien=ro3i, &
+                press_in_edg=press_climoz, paprs=paprs, v3=wo)
+        else
+           ! read_climoz == 2
+           call regr_pr_av(ncid_climoz, (/"tro3         ", &
+                "tro3_daylight"/), julien=ro3i, press_in_edg=press_climoz, &
+                paprs=paprs, v3=wo)
+        end if
+        ! Convert from mole fraction of ozone to column density of ozone in a
+        ! cell, in kDU:
+        forall (l = 1: read_climoz) wo(:, :, l) = wo(:, :, l) * rmo3 / rmd &
+             * zmasse / dobson_u / 1e3
+        ! (By regridding ozone values for LMDZ only once every 360th of
+        ! year, we have already neglected the variation of pressure in one
+        ! 360th of year. So do not recompute "wo" at each time step even if
+        ! "zmasse" changes a little.)
+     
+      ENDIF
     ENDIF
     !
@@ -3034,5 +3033,5 @@
          'lsc',abortphy,flag_inhib_tend)
     rain_num(:)=0.
-    DO k = 1, klev  ! re-evaporation de l'eau liquide nuageuse
+    DO k = 1, klev
        DO i = 1, klon
           IF (ql_seri(i,k)>oliqmax) THEN
@@ -3042,4 +3041,14 @@
        ENDDO
     ENDDO
+    IF (nqo==3) THEN
+    DO k = 1, klev
+       DO i = 1, klon
+          IF (qs_seri(i,k)>oicemax) THEN
+             rain_num(i)=rain_num(i)+(qs_seri(i,k)-oicemax)*zmasse(i,k)/pdtphys
+             qs_seri(i,k)=oicemax
+          ENDIF
+       ENDDO
+    ENDDO
+    ENDIF
 
     !---------------------------------------------------------------------------
@@ -3388,5 +3397,5 @@
                    !
                    CALL readaerosol_optic_rrtm( debut, aerosol_couple, &
-                        new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
+                        new_aod, flag_aerosol, flag_bc_internal_mixture, itap, jD_cur-jD_ref, &
                         pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
                         tr_seri, mass_solu_aero, mass_solu_aero_pi,  &
@@ -4517,5 +4526,7 @@
 
 
+#ifndef CPP_XIOS
     CALL write_paramLMDZ_phy(itap,nid_ctesGCM,ok_sync)
+#endif
 
 #endif
Index: /LMDZ5/branches/testing/libf/phylmd/readaerosol_optic.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/readaerosol_optic.F90	(revision 2668)
+++ /LMDZ5/branches/testing/libf/phylmd/readaerosol_optic.F90	(revision 2669)
@@ -166,7 +166,7 @@
   m_allaer_pi(:,:,id_CSSO4M_phy)  = 0.                   ! CSSO4M pre-ind
   m_allaer_pi(:,:,id_SSSSM_phy)   = sssupco_pi(:,:)      ! SSSSM pre-ind
-  m_allaer_pi(:,:,id_ASSSM_phy)   = sscoarse_pi(:,:)     ! CSSSM pre-ind
-  m_allaer_pi(:,:,id_CIDUSTM_phy) = ssacu_pi(:,:)        ! ASSSM pre-ind
-  m_allaer_pi(:,:,id_AIBCM_phy)   = cidust_pi(:,:)       ! CIDUSTM pre-ind
+  m_allaer_pi(:,:,id_CSSSM_phy)   = sscoarse_pi(:,:)     ! CSSSM pre-ind
+  m_allaer_pi(:,:,id_ASSSM_phy)   = ssacu_pi(:,:)        ! ASSSM pre-ind
+  m_allaer_pi(:,:,id_CIDUSTM_phy) = cidust_pi(:,:)       ! CIDUSTM pre-ind
   m_allaer_pi(:,:,id_AIBCM_phy)   = bcins_pi(:,:)        ! AIBCM pre-ind
   m_allaer_pi(:,:,id_AIPOMM_phy)  = pomins_pi(:,:)       ! AIPOMM pre-ind
